/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ssc.handlers;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.net.Socket;

import org.kie.api.runtime.process.WorkItem;
import org.kie.api.runtime.process.WorkItemHandler;
import org.kie.api.runtime.process.WorkItemManager;

/**
 * This service task handler class is checking linux machine host is reachable or not through socket connection.
 * @author 
 */
public class CheckHostConnectionHandler implements WorkItemHandler {

    @Override
    public void executeWorkItem(WorkItem wi, WorkItemManager wim) {
        System.out.println("print CheckURLHandler info ");
        String hostName = (String) wi.getParameter("HostName");
        boolean status = checkConnectivity(hostName);
        System.out.println(" connection to the host : "+hostName+" and status is :"+status);
        wim.completeWorkItem(wi.getId(), null);
    }

    @Override
    public void abortWorkItem(WorkItem wi, WorkItemManager wim) {
        System.out.println(" process has been aborted");
    }

    public boolean checkConnectivity(String hostName) {

        Socket socket = null;
        boolean isReachable;
        try {
            socket = null;
            isReachable = false;
            java.net.SocketAddress sockaddr = new InetSocketAddress(hostName, 22);
            socket = new Socket();

            socket.connect(sockaddr, 5000);
            isReachable = true;

        } catch (IOException e) {
            throw new RuntimeException(e);
        } finally {
            if (socket != null) {
                try {
                    socket.close();
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
        }
        return isReachable;
    }
}
